#pragma once

#include <condition_variable>
#include <mutex>

#include "page_queue.h"



/* A queue of issued pages. */

class PageQueueShared : public PageQueue
{
protected:
    Queue _queue;
    Positions _positions;

    std::mutex _lock;
    std::condition_variable _counter;

    virtual bool _pop(QueueEntry *entry);

public:
    virtual void pop(PageOwner **owner, Flexpage **flexpage);

    virtual void push(PageOwner *owner, Flexpage *flexpage);

    virtual void push_front(PageOwner *owner, Flexpage *flexpage);

    virtual bool remove(PageOwner *owner, Flexpage *flexpage);
};

// vim: tabstop=4 expandtab shiftwidth=4
